<?php
/**
* MBoard 
* @package project
* @author Wizard <sergejey@gmail.com>
* @copyright http://majordomo.smartliving.ru/ (c)
* @version 0.1 (wizard, 08:06:11 [Jun 04, 2019])
*/
//
//
class mboard_free extends module {
/**
* mboard
*
* Module class constructor
*
* @access private
*/
function __construct() {
  $this->name="mboard_free";
  $this->title="MBoard (free)";
  $this->module_category="<#LANG_SECTION_APPLICATIONS#>";
  $this->checkInstalled();
}
/**
* saveParams
*
* Saving module parameters
*
* @access public
*/
function saveParams($data=1) {
 $p=array();
 if (IsSet($this->id)) {
  $p["id"]=$this->id;
 }
 if (IsSet($this->view_mode)) {
  $p["view_mode"]=$this->view_mode;
 }
 if (IsSet($this->edit_mode)) {
  $p["edit_mode"]=$this->edit_mode;
 }
 if (IsSet($this->tab)) {
  $p["tab"]=$this->tab;
 }
 return parent::saveParams($p);
}
/**
* getParams
*
* Getting module parameters from query string
*
* @access public
*/
function getParams() {
  global $id;
  global $mode;
  global $view_mode;
  global $edit_mode;
  global $tab;
  if (isset($id)) {
   $this->id=$id;
  }
  if (isset($mode)) {
   $this->mode=$mode;
  }
  if (isset($view_mode)) {
   $this->view_mode=$view_mode;
  }
  if (isset($edit_mode)) {
   $this->edit_mode=$edit_mode;
  }
  if (isset($tab)) {
   $this->tab=$tab;
  }
}
/**
* Run
*
* Description
*
* @access public
*/
function run() {
 global $session;
  $out=array();
  if ($this->action=='admin') {
   $this->admin($out);
  } else {
   $this->usual($out);
  }
  if (IsSet($this->owner->action)) {
   $out['PARENT_ACTION']=$this->owner->action;
  }
  if (IsSet($this->owner->name)) {
   $out['PARENT_NAME']=$this->owner->name;
  }
  $out['VIEW_MODE']=$this->view_mode;
  $out['EDIT_MODE']=$this->edit_mode;
  $out['MODE']=$this->mode;
  $out['ACTION']=$this->action;
  $this->data=$out;
  $p=new parser(DIR_TEMPLATES.$this->name."/".$this->name.".html", $this->data, $this);
  $this->result=$p->result;
}
/**
* BackEnd
*
* Module backend
*
* @access public
*/
function admin(&$out) {

}


function evalConsole($code, $print = 0) {
	if($print == 1) {
		if(mb_substr($code, -1) == ';') {
			$code = mb_substr($code, 0, -1);
		}
        ob_start();
        try {
            eval('print_r('.$code.');');
            $result = ob_get_contents();
        } catch (Throwable $t) {
            $result = $t->getMessage();
        }
        ob_get_clean();
		return $result;
	} else {
		ob_start();
        try {
            eval($code);
            $result = ob_get_contents();
        } catch (Throwable $t) {
            $result = $t->getMessage();
        }
        ob_get_clean();
		return $result;
	}
}

function api($params) {
        if ($params['request'][0]=='objects') {
            $objects=SQLSelect("SELECT ID, TITLE, DESCRIPTION FROM objects ORDER BY TITLE");
            return $objects;
        }
        if ($params['request'][0]=='properties') {
            $result = array();
            //$object = $params['request'][1];
            $object=getObject($params['request'][1]);
            //$object->class_id
            $props = $this->getParentProperties($object->class_id, '', 1);
            $my_props = SQLSelect("SELECT ID,TITLE,DESCRIPTION FROM properties WHERE OBJECT_ID='" . $object->id . "'");
            if (IsSet($my_props[0])) {
                foreach ($my_props as $p) {
                    $props[] = $p;
                }
            }
            foreach ($props as $k => $v) {
                $result[] = array("ID"=>$v['ID'], "TITLE"=>$v['TITLE'], "DESCRIPTION"=>$v['DESCRIPTION']);
            }
            return $result;
        }
        if ($params['request'][0]=='decriptions') {
            $list = json_decode(file_get_contents('php://input'), true);
            $result = array();
            if (count($list)>0)
            {
                $objects=SQLSelect("SELECT ID, TITLE, DESCRIPTION FROM objects ORDER BY TITLE");
                
                foreach($list as $value){
                    $obj=explode(".",$value);
                    $key = array_search($obj[0], array_column($objects, 'TITLE'));
                    if ($key !== NULL)
                    {
                        $descObj = $objects[$key]['DESCRIPTION'] == "" ? null : $objects[$key]['DESCRIPTION'];
                        $descProp = null;
                        $object=getObject($obj[0]);
                        $props = $this->getParentProperties($object->class_id, '', 1);
                        $key = array_search($obj[1], array_column($props, 'TITLE'));
                        if ($key !== NULL)
                            $descProp = $props[$key]['DESCRIPTION'] == "" ? null : $props[$key]['DESCRIPTION'];
                        else {
                            $props = SQLSelect("SELECT ID,TITLE,DESCRIPTION FROM properties WHERE OBJECT_ID='" . $objects[$key]["ID"] . "'");
                            $key = array_search($obj[1], array_column($props, 'TITLE'));
                            if ($key !== NULL)
                                $descProp = $props[$key]['DESCRIPTION'] == "" ? null : $props[$key]['DESCRIPTION'];
                        }
                        $result[$value] = array("object"=>$descObj,"property"=>$descProp);
                    }
                }
            }
            return $result;
        }
        if ($params['request'][0]=='methods') {
            $result = array();
            $object=getObject($params['request'][1]);
            $methods = $this->getParentMethods($object->class_id, '', 1);
            foreach ($methods as $k => $v) {
                $result[] = array("ID"=>$v['ID'], "TITLE"=>$v['TITLE'], "DESCRIPTION"=>$v['DESCRIPTION']);
            }
            return $result;
        }
        if ($params['request'][0]=='scripts') {
            $scripts=SQLSelect("SELECT ID, TITLE, DESCRIPTION FROM scripts ORDER BY TITLE");
            return $scripts;
        }
        if ($params['request'][0]=='shouts') {
            $result = array();
            if (!isset($params['begin'])) {
                $shouts=SQLSelect("SELECT * FROM shouts ORDER BY ADDED DESC LIMIT 20");
            }
            else{
                $sql = "SELECT * FROM `shouts` WHERE `ID`<".intval($params['begin'])." ORDER BY ADDED DESC LIMIT 20";
                $shouts=SQLSelect($sql);
            }
            for($i = 0; $i < count($shouts); $i++)
                $shouts[$i]["MEMBER_ID"] = intval($shouts[$i]["MEMBER_ID"]);
            return $shouts;
        }
        if ($params['request'][0]=='command') {
            $qry = "";
            $user_id = "";
            $input = json_decode(file_get_contents('php://input'), true);
            $qry = $input['command'];
            $user_id = $input['user_id'];
            Define('DEVIDER', 'и');
            $qrys = explode(' ' . DEVIDER . ' ', $qry);
            $total = count($qrys);
            for ($i = 0; $i < $total; $i++) {
                $room_id = 0;
                $say_source = 'mboard';
                say(htmlspecialchars($qrys[$i]), 0, $user_id, $say_source);
            }
        }
        if ($params['request'][0]=='console') {
            $result = array();
            $command = $params['command'];
            $code = explode(PHP_EOL, $command);
            foreach($code as $value) {
                $value = trim($value);
                if (substr(mb_strtolower($value), 0, 4) == 'echo' || $value[0] == '$' || preg_match('/include/', $value)) {
                    $result[]=array("code"=>$value, "result"=> $this->evalConsole($value));
                } else {
                    $result[]=array("code"=>$value, "result"=> $this->evalConsole($value,1));
                }
            }
            ob_clean();
            return $result;
        }
        if ($params['request'][0]=='query') {
            $query = $params['query'];
            $result = SQLSelect($query);
            return $result;
        }
        if ($params['request'][0]=='history') {
            if (!isset($params['request'][2])) {
                $start_time = $params['start_time'];
                $stop_time = $params['end_time'];
            }
            else{
                $start_time = $params['request'][2] * 60 * 60  * (-1);
                if ($start_time <= 0) $start_time = (time() + $start_time);
                $stop_time = time();
            }
            
            $id = getHistoryValueId($params['request'][1]);
            if (defined('SEPARATE_HISTORY_STORAGE') && SEPARATE_HISTORY_STORAGE == 1) {
                $table_name = createHistoryTable($id);
            } else {
                $table_name = 'phistory';
            }
            $result = array();
            $sql = "SELECT VALUE, ADDED FROM $table_name WHERE VALUE_ID='" . $id . "' AND ADDED<=('" . date('Y-m-d H:i:s', $start_time) . "') AND ADDED>=('" . date('Y-m-d H:i:s', $start_time - 7 * 24 * 60 * 60) . "') ORDER BY ADDED DESC LIMIT 1";
            $val1 = SQLSelectOne($sql);
            if (!isset($val1['VALUE']))
                $val1 = SQLSelectOne("SELECT VALUE, ADDED FROM $table_name WHERE VALUE_ID='" . $id . "' AND ADDED<=('" . date('Y-m-d H:i:s', $start_time) . "') ORDER BY ADDED DESC LIMIT 1");
            if (isset($val1['VALUE']))
                $result[] = $val1;
            // Get data
            $values = SQLSelect("SELECT VALUE, ADDED FROM $table_name WHERE VALUE_ID='" . $id . "' AND ADDED>=('" . date('Y-m-d H:i:s', $start_time) . "') AND ADDED<=('" . date('Y-m-d H:i:s', $stop_time) . "') ORDER BY ADDED");
            //$values = SQLSelect("SELECT round(avg(VALUE),2) VALUE,  date(ADDED) ADDED FROM $table_name WHERE VALUE_ID='" . $id . "' AND ADDED>=('" . date('Y-m-d H:i:s', $start_time) . "') AND ADDED<=('" . date('Y-m-d H:i:s', $stop_time) . "') group by  date(ADDED) ORDER BY ADDED");
            $result = array_merge($result, $values);
            return  $result;
        }
        if ($params['request'][0]=='login') {
            $login = "";
            $password = "";
            $input = json_decode(file_get_contents('php://input'), true);
            $login = $input['user'];
            $password = $input['password'];
            $user=SQLSelectOne("SELECT * FROM `users` WHERE USERNAME='".$login."' and PASSWORD='".$password."'");
            unset($user["PASSWORD"]);
            return $user;
        }
        if ($params['request'][0]=='user') {
            $login = "";
            $input = json_decode(file_get_contents('php://input'), true);
            $login = $input['user'];
            $user=SQLSelectOne("SELECT * FROM `users` WHERE USERNAME='".$login."'");
            unset($user["PASSWORD"]);
            return $user;
        }
        if ($params['request'][0]=='users') {
            $users=SQLSelect("SELECT ID,USERNAME,NAME,AVATAR FROM `users`");
            for($i = 0; $i < count($users); $i++) {
                $users[$i]["ID"] = (int)$users[$i]["ID"];
            }
            $users[] = array("ID"=>0, "NAME"=>"Алиса", "USERNAME"=>"alice","AVATAR"=>"Alice.jpg");
            return $users;
        }
        if ($params['request'][0]=='config') {
            $user = $params['request'][1];
            $config = "MBoard_".$user;
            $method = $_SERVER['REQUEST_METHOD'];
            $result = array();
            if ($method == 'GET')
            {
                // system
                $result['ip'] = $_SERVER['SERVER_ADDR'];
                $result['ws_port'] = WEBSOCKETS_PORT;
                $result['lang'] = SETTINGS_SITE_LANGUAGE_CODE;
                // config mboard
                $object = getObject($config);
                if ($object){
                    $result['object'] = $object;
                    include_once(DIR_MODULES . 'classes/classes.class.php');
                    $cl = new classes();
                    $props = $cl->getParentProperties($object->class_id, '', 1);
                    $my_props = SQLSelect("SELECT ID,TITLE FROM properties WHERE OBJECT_ID='" . $object->id . "' ORDER BY TITLE");
                    if (IsSet($my_props[0])) {
                        foreach ($my_props as $p) {
                            $props[] = $p;
                        }
                    }
                    foreach ($props as $k => $v) {
                        if (strpos($v['TITLE'],"widgets") !== false )
                            $result["widgets"] .= $object->getProperty($v['TITLE'],true);
                        else
                            $result[$v['TITLE']] = $object->getProperty($v['TITLE'],true);
                    }
                }
            }
            if ($method == 'PUT')
            {
                $input = json_decode(file_get_contents('php://input'), true);

                addClass("MBoard");
                addClassObject("MBoard",$config);
                addClassProperty("MBoard","panels",0);
                addClassProperty("MBoard","widgets",0);
                addClassProperty("MBoard","theme",0);
                addClassProperty("MBoard","debug",0);

                foreach ($input as $key => $value)
                {
                    if ($key == "widgets")
                    {
                        $widgets = $value;
                        $c = 0;
                        $prop = $key;
                        while (strlen($widgets) > 0)
                        {
                            $sw = mb_strcut($widgets, 0, 60000);
                            if ($c > 0)
                                $prop = $key.$c;
                            sg($config.".".$prop,$sw);
                            $widgets = mb_strcut($widgets, strlen($sw));
                            $c = $c + 1;
                        }
                        for($i = $c; $i < 6; $i++)
                            sg($config.".".$key.$i,"");
                    }
                    else
                        sg($config.".".$key,$value);
                }
                $result["result"]="Save config";
            }
            return  $result;
        }
        // API control
        ///api.php/module/mboard_pro/openpanel/dom
        if ($params['request'][0]=='openpanel') {
            $panel = $params['request'][1];
            $res = $this->openPanel($panel);
            return $res;
        }
        ///api.php/module/mboard_pro/viewnotify?text=12345&icon=fas fa-bolt&color=yellow
        if ($params['request'][0]=='viewnotify') {
            $text = $params['text'];
            $icon = $params['icon'];
            $color = $params['color'];
            $res = $this->viewNotify($text,$icon,$color);
            return $res;
        }
        ///api.php/module/mboard_pro/viewinfo?title=title$text=12345&icon=fas fa-bolt&coloricon=%23121212&color=yellow
        if ($params['request'][0]=='viewinfo') {
            if (isset($params['id']))
                $id = $params['id'];
            else
                $id = uniqid();
            $title = $params['title'];
            $text = $params['text'];
            $color = $params['color'];
            $icon = $params['icon'];
            $coloricon = $params['coloricon'];
            $res = $this->viewInfo($id, $title,$text, $color, $icon, $coloricon);
            return $res ? $id : $res;
        }
        ///api.php/module/mboard_pro/closeinfo?id=123
        if ($params['request'][0]=='closeinfo') {
            $id = $params['id'];
            $res = $this->closeInfo($id);
            return $res;
        }
        ///api.php/module/mboard_pro/viewquery?title=title$text=12345&icon=fas fa-bolt&coloricon=%23121212&color=yellow
        ///'buttons'=>array(
        ///"Да_getGlobal"=>array("property"=>"Relay01.asas",'value'=>"1"),
        ///"Незнаю_runMethod"=>array("method"=>"Relay01.switch"),
        ///"Нет_runScript"=>array("script"=>"mboard_event_test"))
        if ($params['request'][0]=='viewquery') {
            if (isset($params['id']))
                $id = $params['id'];
            else
                $id = uniqid();
            $title = $params['title'];
            $text = $params['text'];
            $buttons = $params['buttons'];
            $color = $params['color'];
            $icon = $params['icon'];
            $coloricon = $params['coloricon'];
            $res = $this->viewQuery($id, $title,$text, $buttons, $color, $icon, $coloricon);
            return $res ? $id : $res;
        }
        ///api.php/module/mboard_pro/closequery?id=123
        if ($params['request'][0]=='closequery') {
            $id = $params['id'];
            $res = $this->closeQuery($id);
            return $res;
        }
        ///api.php/module/mboard_pro/theme/(dark/light)
        if ($params['request'][0]=='theme') {
            $theme = $params['request'][1];
            $res = $this->setTheme($theme);
            return $res;
        }
        ///api.php/module/mboard_pro/updatewidget/3j7skdh
        if ($params['request'][0]=='updatewidget') {
            $widget = $params['request'][1];
            $res = $this->updateWidget($widget);
            return $res;
        }
		///api.php/module/mboard_pro/viewhistory?session=jhaiwe2d&title=title$object_value=12345&color=%23121212&step_graph=true
        if ($params['request'][0]=='viewhistory') {
            $session = $params['session'];
            $title = $params['title'];
            $object_value = $params['object_value'];
            $color = $params['color'];
            $step_graph = $params['step_graph'];
            $statuses = json_decode($params['statuses']);
            $res = $this->viewHistory($session,$object_value,$title, $color, $step_graph, $statuses);
            return $res;
        }
        ///api.php/module/mboard_pro/closeinfo?session=jhaiwe2d
        if ($params['request'][0]=='hidehistory') {
            $session = $params['session'];
            $res = $this->hidehistory($session);
            return $res;
        }
        ///api.php/module/mboard_pro/updatetodoer
        if ($params['request'][0]=='updatetodoer') {
            $res = $this->updateTodoer();
            return $res;
        }
        ///api.php/module/mboard_pro/viewtasktodoer/id
        if ($params['request'][0]=='viewtasktodoer') {
            $id = $params['request'][1];
            $res = $this->viewTaskTodoer($id);
            return $res;
        }
        ///api.php/module/mboard_pro/edittasktodoer/id
        if ($params['request'][0]=='edittasktodoer') {
            $id = $params['request'][1];
            $res = $this->editTaskTodoer($id);
            return $res;
        }
        //
        return $params['request'];//"Unknown operation";
}

function openPanel($panel){
    $data = array();
    $data['COMMAND'] = "OpenPanel";
    $data['PANEL'] = $panel;
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function viewNotify($text,$icon,$color){
    $data = array();
    $data['COMMAND'] = "ViewNotify";
    $data['NOTIFY'] = array("text"=>$text, 'icon'=> $icon, "color"=>$color);
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function viewInfo($id, $title, $text, $color, $icon, $coloricon){
    $data = array();
    $data['COMMAND'] = "ViewInfo";
    $data['INFO'] = array(
    'id' => $id,
    'title'=>$title,
    'text'=> $text,
    'color' => $color,
    'icon'=> $icon,
    'coloricon'=>$coloricon);
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function closeInfo($id){
    $data = array();
    $data['COMMAND'] = "CloseInfo";
    $data['INFO'] = array("id"=>$id);
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function viewQuery($id, $title, $text, $buttons, $color, $icon, $coloricon){
 $data = array();
 $data['COMMAND'] = "ViewQuery";
 $data['QUERY'] = array(
    'id' => $id,
    'title'=>$title, 
    'text'=> $text,
    'buttons'=>$buttons,
    'color' => $color,
    'icon'=> $icon,
    'coloricon'=>$coloricon
 );
 $res = postToWebSocket("MBOARD", $data , "PostEvent");
 return $res;
}

function closeQuery($id){
    $data = array();
    $data['COMMAND'] = "CloseQuery";
    $data['QUERY'] = array("id"=>$id);
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

//$res = postToWebSocket("MBOARD", $data , "PostEvent");

function setTheme($theme){
    $data = array();
    $data['COMMAND'] = "Theme";
    $data['THEME'] = $theme;
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function updateWidget($widget){
    $data = array();
    $data['COMMAND'] = "UpdateWidget";
    $data['WIDGET'] = $widget;
    $res = postToWebSocket("MBOARD", $data , "PostEvent");
    return $res;
}

function viewHistory($session,$object_value,$title, $color, $step_graph, $statuses)
{
	$data = array();
	$data['COMMAND'] = "ViewHistory";
	if ($session!='')
		$data['SESSION'] = $session;
	$data['HISTORY'] = array("object_value"=>$object_value, 'title'=> $title, "color"=>$color,"step_graph"=>$step_graph, 
                         "statuses" => $statuses);
	return postToWebSocket("MBOARD", $data , "PostEvent");
}

function hideHistory($session)
{
	$data = array();
	$data['COMMAND'] = "HideHistory";
	$data['SESSION'] = $session;
	return postToWebSocket("MBOARD", $data , "PostEvent");
}

function updateTodoer()
{
	$data = array();
	$data['COMMAND'] = "UpdateTodoer";
	return postToWebSocket("MBOARD", $data , "PostEvent");
}

function viewTaskTodoer($id)
{
	$data = array();
	$data['COMMAND'] = "ViewTaskTodoer";
    $data['ID'] = $id;
	return postToWebSocket("MBOARD", $data , "PostEvent");
}

function editTaskTodoer($id)
{
	$data = array();
	$data['COMMAND'] = "EditTaskTodoer";
    $data['ID'] = $id;
	return postToWebSocket("MBOARD", $data , "PostEvent");
}

function getParentProperties($id, $def='', $include_self=0) {
  $class=SQLSelectOne("SELECT * FROM classes WHERE ID='".(int)$id."'");

  $properties=SQLSelect("SELECT properties.*, classes.TITLE as CLASS_TITLE, properties.DESCRIPTION  FROM properties LEFT JOIN classes ON properties.CLASS_ID=classes.ID WHERE CLASS_ID='".$id."' AND OBJECT_ID=0");

  if ($include_self) {
   $res=$properties;
  } else {
   $res=array();
  }

  if (!is_array($def)) {
   $def=array();
   foreach($properties as $p) {
    $def[]=$p['TITLE'];
   }
  }

  foreach($properties as $p) {
   if (!in_array($p['TITLE'], $def)) {
    $res[]=$p;
    $def[]=$p['TITLE'];
   }
  }

  if ($class['PARENT_ID']) {
   $p_res=$this->getParentProperties($class['PARENT_ID'], $def);
   if ($p_res[0]['ID']) {
    $res=array_merge($res, $p_res);
   }
  }

  return $res;

 }
 function getParentMethods($id, $def='', $include_self=0) {
  $class=SQLSelectOne("SELECT * FROM classes WHERE ID='".(int)$id."'");

  $methods=SQLSelect("SELECT methods.*, classes.TITLE as CLASS_TITLE FROM methods LEFT JOIN classes ON methods.CLASS_ID=classes.ID WHERE CLASS_ID='".$id."' AND OBJECT_ID=0");

  if ($include_self) {
   $res=$methods;
  } else {
   $res=array();
  }
  


  if (!is_array($def)) {
   $def=array();
   foreach($methods as $p) {
    $def[]=$p['TITLE'];
   }
  }

  foreach($methods as $p) {
   if (!in_array($p['TITLE'], $def)) {
    $res[]=$p;
    $def[]=$p['TITLE'];
   }
  }

  if ($class['PARENT_ID']) {
   $p_res=$this->getParentMethods($class['PARENT_ID'], $def);
   if ($p_res[0]['ID']) {
    $res=array_merge($res, $p_res);
   }
  }

  return $res;

 }


/**
* FrontEnd
*
* Module frontend
*
* @access public
*/
function usual(&$out) {
 $this->admin($out);
}
/**
* Install
*
* Module installation routine
*
* @access private
*/
 function install($data='') {
  parent::install();
 }
// --------------------------------------------------------------------
}
/*
*
* TW9kdWxlIGNyZWF0ZWQgSnVuIDA0LCAyMDE5IHVzaW5nIFNlcmdlIEouIHdpemFyZCAoQWN0aXZlVW5pdCBJbmMgd3d3LmFjdGl2ZXVuaXQuY29tKQ==
*
*/
